Attribute VB_Name = "RepMeasures"
Option Explicit

Sub RepMeasure()
Attribute RepMeasure.VB_Description = "Runs Repeated Measure ANOVA on output from TS4 include system RepMeasures"
Attribute RepMeasure.VB_ProcData.VB_Invoke_Func = "R\r14"
'
' RepMeasure Macro
' Macro recorded 9/1/1998 by Paul H. Lasky
' Use with Trade Station 4, Include System: Rep Measures.1
'

'
    Dim x1Down As Byte, j As Object, j1 As Object, j2 As Object
    Dim countdelete As Integer, rowclearcnt As Integer
    Dim rowdataend As Integer
    
    
    Rows("1:1").Select
    
    Selection.Insert Shift:=x1Down
    Selection.Insert Shift:=xlDown
    Selection.Insert Shift:=xlDown
    Selection.Insert Shift:=xlDown
    Selection.Insert Shift:=xlDown
    Selection.Insert Shift:=xlDown
    Selection.Insert Shift:=xlDown
    Selection.Insert Shift:=xlDown
    Selection.Insert Shift:=xlDown
   
    ' The following subroutine reads the first column of data from TS4
    ' and calculates N and K taking into account that TS4 duplicates the data
    ' for giving the max return. So K is calculated as Kc - 1 where Kc is the number of parameter runs
    ' outputted by TS4
    '
        
     Call CountNK
     
     ' Wipe out last k+2 cells as TS4 duplicates the data for the parameter
     ' the data for parameter setting that gives the max profit.
     ' The extra data is placed after the data corresponding to the last parameter
     ' setting and it must be eliminated before calculating the sums for ANOVA.
     
     rowclearcnt = Cells(2, 1).Value * (Cells(1, 1).Value + 2)
     rowdataend = (Cells(2, 1).Value + 1) * (Cells(1, 1).Value + 2) + 9
     
     Set j = ActiveSheet.Range("a10")
     For countdelete = 1 To rowdataend
       Set j1 = j.Offset(1, 0)
       Set j2 = j.Offset(0, 1)
      If countdelete > rowclearcnt Then
        j.ClearContents
        j2.ClearContents
      End If
       Set j = j1
     Next
      
    Range("C10").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-2]=""Sxie-3"",RC[-1],"""")"
    Selection.AutoFill Destination:=Range("C10:C280"), Type:=xlFillDefault
     
    Range("B9").FormulaR1C1 = "=SUM(R[1]C[1]:R[270]C[1])"
    Range("C9").FormulaR1C1 = "=(RC[-1]*RC[-1])/(R1C1*R2C1)"
    
    Range("D11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-3]=""Ssxie-6"",RC[-2],"""")"
    Selection.AutoFill Destination:=Range("D11:D280"), Type:=xlFillDefault
        
    Range("D10").Select
    ActiveCell.FormulaR1C1 = "=SUM(R[1]C:R[270]C)"
    Selection.Cut Destination:=Range("D9")
    
    Range("E10").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-4]=""Sxie-3"",RC[-3]*RC[-3],"""")"
    Selection.AutoFill Destination:=Range("E10:E280"), Type:=xlFillDefault
    
    Range("E9").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/R1C1"
    
    Range("G11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-6]=1,RC[-5],"""")"
    Selection.AutoFill Destination:=Range("G11:G280"), Type:=xlFillDefault
    
    Range("G10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("G9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("H11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-7]=2,RC[-6],"""")"
    Selection.AutoFill Destination:=Range("H11:H280"), Type:=xlFillDefault
    
    Range("H10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("H9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("I11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-8]=3,RC[-7],"""")"
    Selection.AutoFill Destination:=Range("I11:I280"), Type:=xlFillDefault
    
    Range("I10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("I9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("J11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-9]=4,RC[-8],"""")"
    Selection.AutoFill Destination:=Range("J11:J280"), Type:=xlFillDefault
   
    Range("J10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("J9").FormulaR1C1 = "=R[1]C*R[1]C"
   
    Range("K11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-10]=5,RC[-9],"""")"
    Selection.AutoFill Destination:=Range("K11:K280"), Type:=xlFillDefault
   
    Range("K10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("K9").FormulaR1C1 = "=R[1]C*R[1]C"
   
    Range("L11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-11]=6,RC[-10],"""")"
    Selection.AutoFill Destination:=Range("L11:L280"), Type:=xlFillDefault
    
    Range("L10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("L9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("M11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-12]=7,RC[-11],"""")"
    Selection.AutoFill Destination:=Range("M11:M280"), Type:=xlFillDefault
    
    Range("M10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("M9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("N11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-13]=8,RC[-12],"""")"
    Selection.AutoFill Destination:=Range("N11:N280"), Type:=xlFillDefault
    
    Range("N10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("N9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("O11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-14]=9,RC[-13],"""")"
    Selection.AutoFill Destination:=Range("O11:O280"), Type:=xlFillDefault
    
    Range("O10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("O9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    
    Range("P11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-15]=10,RC[-14],"""")"
    Selection.AutoFill Destination:=Range("P11:P280"), Type:=xlFillDefault
    
    Range("P10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("P9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("Q11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-16]=11,RC[-15],"""")"
    Selection.AutoFill Destination:=Range("Q11:Q280"), Type:=xlFillDefault
    
    Range("Q10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("Q9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("R11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-17]=12,RC[-16],"""")"
    Selection.AutoFill Destination:=Range("R11:R280"), Type:=xlFillDefault
    
    Range("R10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("R9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("S11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-18]=13,RC[-17],"""")"
    Selection.AutoFill Destination:=Range("S11:S280"), Type:=xlFillDefault
    
    Range("S10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("S9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("T11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-19]=14,RC[-18],"""")"
    Selection.AutoFill Destination:=Range("T11:T280"), Type:=xlFillDefault
    
    Range("T10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("T9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("U11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-20]=15,RC[-19],"""")"
    Selection.AutoFill Destination:=Range("U11:U280"), Type:=xlFillDefault
    
    Range("U10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("U9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("V11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-21]=16,RC[-20],"""")"
    Selection.AutoFill Destination:=Range("V11:V280"), Type:=xlFillDefault
    
    Range("V10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("V9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("W11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-22]=17,RC[-21],"""")"
    Selection.AutoFill Destination:=Range("W11:W280"), Type:=xlFillDefault
    
    Range("W10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("W9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("X11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-23]=18,RC[-22],"""")"
    Selection.AutoFill Destination:=Range("X11:X280"), Type:=xlFillDefault
    
    Range("X10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("X9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("Y11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-24]=19,RC[-23],"""")"
    Selection.AutoFill Destination:=Range("Y11:Y280"), Type:=xlFillDefault
    
    Range("Y10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("Y9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("Z11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-25]=20,RC[-24],"""")"
    Selection.AutoFill Destination:=Range("Z11:Z280"), Type:=xlFillDefault
    
    Range("Z10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("Z9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("AA11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-26]=21,RC[-25],"""")"
    Selection.AutoFill Destination:=Range("AA11:AA280"), Type:=xlFillDefault
    
    Range("AA10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("AA9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("AB11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-27]=22,RC[-26],"""")"
    Selection.AutoFill Destination:=Range("AB11:AB280"), Type:=xlFillDefault
    
    Range("AB10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("AB9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("AC11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-28]=23,RC[-27],"""")"
    Selection.AutoFill Destination:=Range("AC11:AC280"), Type:=xlFillDefault
    
    Range("AC10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("AC9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("AD11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-29]=24,RC[-28],"""")"
    Selection.AutoFill Destination:=Range("AD11:AD280"), Type:=xlFillDefault
    
    Range("AD10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("AD9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    Range("AE11").Select
    ActiveCell.FormulaR1C1 = "=IF(RC[-30]=25,RC[-29],"""")"
    Selection.AutoFill Destination:=Range("AE11:AE280"), Type:=xlFillDefault
    
    Range("AE10").FormulaR1C1 = "=SUM(R[1]C:R[270]C)/1000"
    Range("AE9").FormulaR1C1 = "=R[1]C*R[1]C"
    
    
    Range("F9").FormulaR1C1 = "=SUM(RC[1]:RC[25])/R2C1"
    Range("C8").FormulaR1C1 = "=R[1]C[1]-R[1]C[3]"
    Range("D8").FormulaR1C1 = "=R[1]C[1]-R[1]C[-1]"
    Range("E8").FormulaR1C1 = "=RC[-2]-RC[-1]"
        
    Rows("8:280").Select
    Selection.EntireRow.Hidden = True
    
    Range("D1").FormulaR1C1 = "One Factor ANOVA"
    Range("D3").FormulaR1C1 = "Mean Square Error"
    Range("F3").FormulaR1C1 = "df"
    Range("G3").FormulaR1C1 = "F"
    Range("C4").FormulaR1C1 = "Parameter"
    Range("C5").FormulaR1C1 = "Residual"
    Range("C7").FormulaR1C1 = "Significant with"
    Range("F4").FormulaR1C1 = "=R2C1-1"
    Range("F5").FormulaR1C1 = "=(R2C1-1)*(R1C1-1)"
    Range("D4").FormulaR1C1 = "=R[4]C/RC[2]"
    Range("D5").FormulaR1C1 = "=R[3]C[1]/RC[2]"
    Range("G4").FormulaR1C1 = "=RC[-3]/R[1]C[-3]"
    Range("F7").FormulaR1C1 = "% Confidence"
    
    Range("E7").Select
    ActiveCell.FormulaR1C1 = "=100*(1-FDIST(ABS(R[-3]C[2]),R[-3]C[1],R[-2]C[1]))"
    Selection.NumberFormat = "0.00"
            
    Range("C1:G1").Select
    With Selection.Font
        .Name = "Arial"
        .FontStyle = "Regular"
        .Size = 12
        .ColorIndex = xlAutomatic
    End With
    With Selection.Interior
        .ColorIndex = 15
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    
    Range("C3:G3").Select
    With Selection.Font
        .Name = "Arial"
        .FontStyle = "Bold"
        .Size = 9
        .ColorIndex = xlAutomatic
    End With
    With Selection.Interior
        .ColorIndex = 39
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    
    
    Range("C2:G2").Select
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Interior
        .ColorIndex = 15
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    
    Range("C4:G6").Select
    Selection.NumberFormat = "0.0000"
    With Selection.Interior
        .ColorIndex = 15
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    
    Range("F4:F5").Select
    Selection.NumberFormat = "0"
    With Selection
        .HorizontalAlignment = xlCenter
        .VerticalAlignment = xlBottom
     End With
    
    Range("C6:G6").Select
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
   
    Range("C7:G7").Select
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Interior
        .ColorIndex = 39
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    
    Range("F3").Select
    With Selection
        .HorizontalAlignment = xlCenter
        .VerticalAlignment = xlBottom
    End With
    
    Range("G3").Select
    With Selection
        .HorizontalAlignment = xlCenter
        .VerticalAlignment = xlBottom
    End With
    
    Columns("A:A").Select
    Selection.EntireColumn.Hidden = True
    
    Range("C282").FormulaR1C1 = "N (No. of Measures) = "
    Range("C283").FormulaR1C1 = "K (No.of Parameter Levels) = "
    Range("F282").FormulaR1C1 = "=R1C1"
    Range("F283").FormulaR1C1 = "=R2C1"
    
    Range("C282:F283").Select
    With Selection.Interior
        .ColorIndex = 34
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    
    Range("C282").Select
    With Selection.Borders(xlEdgeLeft)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlEdgeTop)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Interior
        .ColorIndex = 24
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    
    Range("D282:E282").Select
    With Selection.Borders(xlEdgeTop)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    
    With Selection.Interior
        .ColorIndex = 24
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    
    Range("F282").Select
    With Selection.Borders(xlEdgeTop)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlEdgeRight)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Interior
        .ColorIndex = 24
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    
    Range("C283").Select
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Interior
        .ColorIndex = 24
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlEdgeLeft)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    Selection.Borders(xlEdgeTop).LineStyle = xlNone
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    
    Range("D283:E283").Select
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Interior
        .ColorIndex = 24
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
    
    Range("F283").Select
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlEdgeRight)
        .LineStyle = xlContinuous
        .Weight = xlMedium
        .ColorIndex = xlAutomatic
    End With
    With Selection.Interior
        .ColorIndex = 24
        .Pattern = xlSolid
        .PatternColorIndex = xlAutomatic
    End With
   
      Call StudentRangeTest
    
    Range("a3").Select
End Sub

Sub CountNK()
Attribute CountNK.VB_ProcData.VB_Invoke_Func = " \r14"
 ' Counts the TS4 Repmeasures output file in Column A to
 ' determine N and K
   Dim n As Integer, k As Integer, term As Integer
   Dim j As Object, j1 As Object, result1 As Integer, result2 As Integer
   n = 0
   k = 0
   Set j = Range("a10")
   Do While Not IsEmpty(j)
      Set j1 = j.Offset(1, 0)
      If j.Value = "Ssxie-6" Then k = k + 1
      If k = 1 And (j.Value <> "Ssxie-6") Then n = n + 1
      Set j = j1
   Loop
   n = n - 1
   k = k - 1
   term = 0
   If n < 2 Then
      result1 = MsgBox("Sorry, N < 2, I must terminate")
      term = 1
   End If
   If k < 2 Then
      result2 = MsgBox("Sorry, K < 2, I must terminate")
      term = term + 1
   End If
   If term > 0 Then Application.Quit
      Cells(1, 1).Formula = n
      Cells(2, 1).Formula = k
   End Sub

Sub StudentRangeTest()
Attribute StudentRangeTest.VB_ProcData.VB_Invoke_Func = " \r14"
'
' Macro recorded 9/17/1998, Rational Approx 11/10/98 by Paul H. Lasky
' Calculates Maximum and Minimum Total Return over all Measures
'   and compares difference with Qcrit[.1, k, (n-1)*(k-1)]*Sqrt(n*MSE)
' Keyboard Shortcut: Ctrl+Shift+Q
'
' Approximates Critical Value for 90% confidence Studentnized Range
' v is degrees of freedom, k is number of treatments or parameter sets.
' Uses rational approximation to Qcrit(0.1) by transforming v.
 Dim x As Single, numx As Single, numk As Single, denomx As Single, denomk As Single
 Dim v As Single, k As Single, n As Single, Qcrit As Single, MSE As Single, TotRetCrit As Single
 v = Cells(5, 6)
 k = Cells(2, 1)
 n = Cells(1, 1)
 x = 1 / (1 + (-1.4574 + 0.021744 * k) * v)
 numx = 1.262789 + (-11.5166 + 24.26764 * x) * x
 numk = 0.545705 + 1.207072 * k
 denomx = 1 + (-7.00913 + 3.961523 * x) * x
 denomk = 1 + 0.283403 * k
 Qcrit = numx * numk / (denomx * denomk)
 MSE = Cells(5, 4)
 TotRetCrit = Qcrit * Sqr(Abs(n * MSE))
 '
 ' Commence the Formating
 '
    Columns("L:L").ColumnWidth = 10.43
    Range("J1").Select
    ActiveCell.FormulaR1C1 = "Studentized Range Test"
    Range("I1:M2").Select
    With Selection.Font
        .Name = "Arial"
        .FontStyle = "Regular"
        .Size = 12
    End With
    With Selection.Interior
        .ColorIndex = 15
    End With
    Range("I3").Select
    ActiveCell.FormulaR1C1 = "Para. Set"
    Range("J3").Select
    ActiveCell.FormulaR1C1 = "Total Ret."
    Range("K3").Select
    ActiveCell.FormulaR1C1 = "Diff."
    Range("L3").Select
    ActiveCell.FormulaR1C1 = "Sig. Diff.(90%)"
    Range("I3:M3").Select
    With Selection
        .HorizontalAlignment = xlCenter
        .VerticalAlignment = xlBottom
    End With
    With Selection.Font
        .Name = "Arial"
        .FontStyle = "Bold"
        .Size = 9
    End With
   
    With Selection.Borders(xlEdgeTop)
        .LineStyle = xlContinuous
        .Weight = xlMedium
    End With
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
    End With
    
    With Selection.Interior
        .ColorIndex = 39
    End With
    Range("I4").Select
    ActiveCell.FormulaR1C1 = "Maximum"
    Range("I5").Select
    ActiveCell.FormulaR1C1 = "Minimum"
    Range("J4").Select
    ActiveCell.FormulaR1C1 = "=MAX(R[6]C[-7]:R[275]C[-7])"
    Range("J5").Select
    ActiveCell.FormulaR1C1 = "=MIN(R[5]C[-7]:R[274]C[-7])"
    Range("K4").Select
    ActiveCell.FormulaR1C1 = "=RC[-1]-R[1]C[-1]"
    Range("L4").Select
    '
    ' place Qcrit*Sqrt(MSE*n) calculation in Cell L4
    '
    Selection.Cells.Value = TotRetCrit
    '
    ' Complete Formating
    Range("I4:M6").Select
    With Selection.Interior
        .ColorIndex = 15
    End With
    Range("J4:J5").Select
    Selection.NumberFormat = "0"
    Range("K4:L4").Select
    Selection.NumberFormat = "0.00"
    Range("I7").Select
    ActiveCell.FormulaR1C1 = _
        "=IF(R[-3]C[2]>R[-3]C[3],""Difference Significant with 90% Confidence"",""Difference NOT Significant with 90% Confidence"")"
    Range("I7:M7").Select
    With Selection.Borders(xlEdgeTop)
        .LineStyle = xlContinuous
        .Weight = xlMedium
    End With
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlMedium
    End With
   
    With Selection.Interior
        .ColorIndex = 39
    End With
End Sub
